/* enums.c generated by valac 0.38.1, the Vala compiler
 * generated from enums.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "gnome-pomodoro.h"
#include <glib/gi18n-lib.h>


#define ACTIONS_TYPE_STATE (actions_state_get_type ())
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

#define ACTIONS_TYPE_TRIGGER (actions_trigger_get_type ())

typedef enum  {
	ACTIONS_STATE_NONE = 0,
	ACTIONS_STATE_POMODORO = 1,
	ACTIONS_STATE_SHORT_BREAK = 2,
	ACTIONS_STATE_LONG_BREAK = 4,
	ACTIONS_STATE_ANY = (ACTIONS_STATE_POMODORO | ACTIONS_STATE_SHORT_BREAK) | ACTIONS_STATE_LONG_BREAK
} ActionsState;

typedef enum  {
	ACTIONS_TRIGGER_NONE = 0,
	ACTIONS_TRIGGER_START = 1,
	ACTIONS_TRIGGER_COMPLETE = 2,
	ACTIONS_TRIGGER_SKIP = 4,
	ACTIONS_TRIGGER_PAUSE = 8,
	ACTIONS_TRIGGER_RESUME = 16,
	ACTIONS_TRIGGER_ENABLE = 32,
	ACTIONS_TRIGGER_DISABLE = 64
} ActionsTrigger;



GType actions_state_get_type (void) G_GNUC_CONST;
GList* actions_state_to_list (ActionsState self);
gchar* actions_state_to_string (ActionsState self);
ActionsState actions_state_from_timer_state (PomodoroTimerState* timer_state);
gchar* actions_state_get_label (ActionsState self);
GType actions_trigger_get_type (void) G_GNUC_CONST;
GList* actions_trigger_to_list (ActionsTrigger self);
gchar* actions_trigger_to_string (ActionsTrigger self);
gchar* actions_trigger_get_label (ActionsTrigger self);


GList* actions_state_to_list (ActionsState self) {
	GList* result = NULL;
	GList* states = NULL;
	states = NULL;
	if ((self & ACTIONS_STATE_LONG_BREAK) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_STATE_LONG_BREAK));
	}
	if ((self & ACTIONS_STATE_SHORT_BREAK) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_STATE_SHORT_BREAK));
	}
	if ((self & ACTIONS_STATE_POMODORO) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_STATE_POMODORO));
	}
	result = states;
	return result;
}


gchar* actions_state_to_string (ActionsState self) {
	gchar* result = NULL;
	gchar* _tmp3_;
	switch (self) {
		case ACTIONS_STATE_POMODORO:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("pomodoro");
			result = _tmp0_;
			return result;
		}
		case ACTIONS_STATE_SHORT_BREAK:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("short-break");
			result = _tmp1_;
			return result;
		}
		case ACTIONS_STATE_LONG_BREAK:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("long-break");
			result = _tmp2_;
			return result;
		}
		default:
		break;
	}
	_tmp3_ = g_strdup ("");
	result = _tmp3_;
	return result;
}


ActionsState actions_state_from_timer_state (PomodoroTimerState* timer_state) {
	ActionsState result = 0;
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
	g_return_val_if_fail (timer_state != NULL, 0);
	_tmp0_ = timer_state;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, POMODORO_TYPE_POMODORO_STATE)) {
		result = ACTIONS_STATE_POMODORO;
		return result;
	}
	_tmp1_ = timer_state;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, POMODORO_TYPE_SHORT_BREAK_STATE)) {
		result = ACTIONS_STATE_SHORT_BREAK;
		return result;
	}
	_tmp2_ = timer_state;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, POMODORO_TYPE_LONG_BREAK_STATE)) {
		result = ACTIONS_STATE_LONG_BREAK;
		return result;
	}
	result = ACTIONS_STATE_NONE;
	return result;
}


gchar* actions_state_get_label (ActionsState self) {
	gchar* result = NULL;
	gchar* _tmp3_;
	switch (self) {
		case ACTIONS_STATE_POMODORO:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Pomodoro"));
			result = _tmp0_;
			return result;
		}
		case ACTIONS_STATE_SHORT_BREAK:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Short Break"));
			result = _tmp1_;
			return result;
		}
		case ACTIONS_STATE_LONG_BREAK:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Long Break"));
			result = _tmp2_;
			return result;
		}
		default:
		break;
	}
	_tmp3_ = g_strdup ("");
	result = _tmp3_;
	return result;
}


GType actions_state_get_type (void) {
	static volatile gsize actions_state_type_id__volatile = 0;
	if (g_once_init_enter (&actions_state_type_id__volatile)) {
		static const GFlagsValue values[] = {{ACTIONS_STATE_NONE, "ACTIONS_STATE_NONE", "none"}, {ACTIONS_STATE_POMODORO, "ACTIONS_STATE_POMODORO", "pomodoro"}, {ACTIONS_STATE_SHORT_BREAK, "ACTIONS_STATE_SHORT_BREAK", "short-break"}, {ACTIONS_STATE_LONG_BREAK, "ACTIONS_STATE_LONG_BREAK", "long-break"}, {ACTIONS_STATE_ANY, "ACTIONS_STATE_ANY", "any"}, {0, NULL, NULL}};
		GType actions_state_type_id;
		actions_state_type_id = g_flags_register_static ("ActionsState", values);
		g_once_init_leave (&actions_state_type_id__volatile, actions_state_type_id);
	}
	return actions_state_type_id__volatile;
}


GList* actions_trigger_to_list (ActionsTrigger self) {
	GList* result = NULL;
	GList* states = NULL;
	states = NULL;
	if ((self & ACTIONS_TRIGGER_DISABLE) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_DISABLE));
	}
	if ((self & ACTIONS_TRIGGER_ENABLE) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_ENABLE));
	}
	if ((self & ACTIONS_TRIGGER_RESUME) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_RESUME));
	}
	if ((self & ACTIONS_TRIGGER_PAUSE) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_PAUSE));
	}
	if ((self & ACTIONS_TRIGGER_SKIP) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_SKIP));
	}
	if ((self & ACTIONS_TRIGGER_COMPLETE) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_COMPLETE));
	}
	if ((self & ACTIONS_TRIGGER_START) != 0) {
		states = g_list_prepend (states, (gpointer) ((gintptr) ACTIONS_TRIGGER_START));
	}
	result = states;
	return result;
}


gchar* actions_trigger_to_string (ActionsTrigger self) {
	gchar* result = NULL;
	gchar* _tmp7_;
	switch (self) {
		case ACTIONS_TRIGGER_START:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("start");
			result = _tmp0_;
			return result;
		}
		case ACTIONS_TRIGGER_COMPLETE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("complete");
			result = _tmp1_;
			return result;
		}
		case ACTIONS_TRIGGER_SKIP:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("skip");
			result = _tmp2_;
			return result;
		}
		case ACTIONS_TRIGGER_PAUSE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("pause");
			result = _tmp3_;
			return result;
		}
		case ACTIONS_TRIGGER_RESUME:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("resume");
			result = _tmp4_;
			return result;
		}
		case ACTIONS_TRIGGER_ENABLE:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("enable");
			result = _tmp5_;
			return result;
		}
		case ACTIONS_TRIGGER_DISABLE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("disable");
			result = _tmp6_;
			return result;
		}
		default:
		break;
	}
	_tmp7_ = g_strdup ("");
	result = _tmp7_;
	return result;
}


gchar* actions_trigger_get_label (ActionsTrigger self) {
	gchar* result = NULL;
	gchar* _tmp7_;
	switch (self) {
		case ACTIONS_TRIGGER_START:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Start"));
			result = _tmp0_;
			return result;
		}
		case ACTIONS_TRIGGER_COMPLETE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Complete"));
			result = _tmp1_;
			return result;
		}
		case ACTIONS_TRIGGER_SKIP:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Skip"));
			result = _tmp2_;
			return result;
		}
		case ACTIONS_TRIGGER_PAUSE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Pause"));
			result = _tmp3_;
			return result;
		}
		case ACTIONS_TRIGGER_RESUME:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Resume"));
			result = _tmp4_;
			return result;
		}
		case ACTIONS_TRIGGER_ENABLE:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Enable"));
			result = _tmp5_;
			return result;
		}
		case ACTIONS_TRIGGER_DISABLE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Disable"));
			result = _tmp6_;
			return result;
		}
		default:
		break;
	}
	_tmp7_ = g_strdup ("");
	result = _tmp7_;
	return result;
}


GType actions_trigger_get_type (void) {
	static volatile gsize actions_trigger_type_id__volatile = 0;
	if (g_once_init_enter (&actions_trigger_type_id__volatile)) {
		static const GFlagsValue values[] = {{ACTIONS_TRIGGER_NONE, "ACTIONS_TRIGGER_NONE", "none"}, {ACTIONS_TRIGGER_START, "ACTIONS_TRIGGER_START", "start"}, {ACTIONS_TRIGGER_COMPLETE, "ACTIONS_TRIGGER_COMPLETE", "complete"}, {ACTIONS_TRIGGER_SKIP, "ACTIONS_TRIGGER_SKIP", "skip"}, {ACTIONS_TRIGGER_PAUSE, "ACTIONS_TRIGGER_PAUSE", "pause"}, {ACTIONS_TRIGGER_RESUME, "ACTIONS_TRIGGER_RESUME", "resume"}, {ACTIONS_TRIGGER_ENABLE, "ACTIONS_TRIGGER_ENABLE", "enable"}, {ACTIONS_TRIGGER_DISABLE, "ACTIONS_TRIGGER_DISABLE", "disable"}, {0, NULL, NULL}};
		GType actions_trigger_type_id;
		actions_trigger_type_id = g_flags_register_static ("ActionsTrigger", values);
		g_once_init_leave (&actions_trigger_type_id__volatile, actions_trigger_type_id);
	}
	return actions_trigger_type_id__volatile;
}



